package com.malk.ruisi.controller;

/**
 * 错误抛出与拦截详见 CatchException
 */

import com.malk.ruisi.service.RSService;
import com.malk.server.common.McException;
import com.malk.server.common.McR;
import com.malk.utils.UtilServlet;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

@Slf4j
@RestController
@RequestMapping
public class CosController {

    @Autowired
    private RSService rsService;

    /**
     * 创建投资人用户
     */
    @PostMapping("user/sync")
    McR syncUser() {
        
        log.info("syncUser");
        rsService.syncDingTalk_exclusive();
        return McR.success();
    }

    /**
     * 重置密码流程
     */
    @PostMapping("reset")
    McR resetPwd(HttpServletRequest request) {

        Map data = UtilServlet.getParamMap(request);
        log.info("reset, {}", data);

        McException.assertParamException_Null(data, "userId", "password");
        rsService.resetPwd(data);
        return McR.success();
    }

    @PostMapping("test")
    McR test() {

        return McR.success();
    }

    /**
     * 资讯卡片
     * 1. 接口格式为 formData, 宜搭服务注册一致
     * 2. 工作台页面不支持配置参数, 需要通过接口区分
     */
    @PostMapping("portal/cw")
    List<Map> portal(HttpServletRequest request) {

        Map data = UtilServlet.getParamMap(request);
        log.info("工作台数据, {}", data);
        return rsService.getPortalList("财务专区");
    }

    @PostMapping("portal/gs")
    List<Map> portal1(HttpServletRequest request) {

        Map data = UtilServlet.getParamMap(request);
        log.info("工作台数据, {}", data);
        return rsService.getPortalList("公司头条");
    }

    @PostMapping("portal/qy")
    List<Map> portal2(HttpServletRequest request) {

        Map data = UtilServlet.getParamMap(request);
        log.info("工作台数据, {}", data);
        return rsService.getPortalList("企业文化");
    }

    @PostMapping("portal/yg")
    List<Map> portal3(HttpServletRequest request) {

        Map data = UtilServlet.getParamMap(request);
        log.info("工作台数据, {}", data);
        return rsService.getPortalList("员工自助");
    }

    @PostMapping("portal/gz")
    List<Map> portal4(HttpServletRequest request) {

        Map data = UtilServlet.getParamMap(request);
        log.info("工作台数据, {}", data);
        return rsService.getPortalList("规章制度");
    }
    /// 流程分享权限 1. 发起人可操作权限 2. 配置弹出框在可编辑权限
    @PostMapping("share/record")
    McR shareRecord(@RequestParam String processInstanceId, @RequestBody Map data) {

        log.info("流程分享权限, {}, {}", processInstanceId, data);
        rsService.shareRecord(processInstanceId, data);



        return McR.success();
    }
}
