package com.malk.ruisi.controller;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.malk.ruisi.service.QysService;
import com.malk.ruisi.service.RsQysService;
import com.malk.ruisi.service.impl.dingshiqiImpl;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McException;
import com.malk.server.common.McR;
import com.malk.server.dingtalk.DDConf;
import com.malk.service.aliwork.YDClient;
import com.malk.service.aliwork.YDService;
import com.malk.service.dingtalk.DDClient;
import com.malk.utils.UtilHttp;
import com.malk.utils.UtilMap;
import lombok.extern.slf4j.Slf4j;
import org.apache.xmlbeans.impl.jam.mutable.MClass;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.Resource;
import org.springframework.core.io.UrlResource;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.io.IOException;
import java.net.MalformedURLException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.*;

@RestController
@Slf4j
@RequestMapping("/qys")
public class QysHuiDaoController {
    @Autowired
    private RsQysService qysService;
    @Autowired
    private YDClient ydClient;
    @Autowired
    private YDConf ydConf;
    @Autowired
    private DDConf ddConf;
    @Autowired
    private DDClient ddClient;
    @PostMapping("/person")
    //传入实例Id获取实例数据
    public McR person(@RequestBody Map map) throws Exception {
        log.info("param:{}", map);
        List<String> list = (List<String>) map.get("formInstanceId");
        List<String> result = new ArrayList<>();
        for (String s : list) {
            Map formData = (Map) ydClient.queryData(YDParam.builder().formInstId(s)
                    .appType(ydConf.getAppType()).systemToken(ydConf.getSystemToken())
                    .userId(ddConf.getOperator()).build(), YDConf.FORM_QUERY.retrieve_id).getFormData();
            log.info("formData:{}", formData);

            List<String> aa2 = (List<String>) formData.get("employeeField_lwr509pq");
            System.out.println(aa2);
            //用for循环遍历一下aa2集合
            result.addAll(aa2);
        }
        Set<String> result1 = new HashSet<>(result);
        List<Map> r = new ArrayList<>();
        for (String s1 : result1) {
            Map<String, String> name1 = new HashMap<>();
            int start = s1.indexOf('(');
            int end = s1.indexOf(')');
            if (start != -1 && end != -1) {
                String name = s1.substring(0, start);
                String id = s1.substring(start + 1, end);
                name1.put("label", name);
                name1.put("value", id);
            }
            r.add(name1);
        }
        return McR.success(r);
    }
    @Autowired
    private YDService ydService;
//更新表单字段
    @GetMapping("/test20")
    McR test12() {
        ydClient.operateData(YDParam.builder()
                .formInstanceId("9f32c151-956d-4f4a-a175-c31cbcc8c905")
                .updateFormDataJson(JSONObject.toJSONString(UtilMap.map("departmentSelectField_lys0k6qb",Arrays.asList("154981944"))))
                        .useLatestVersion(true)
                        .build(), YDConf.FORM_OPERATION.update);
        return McR.success();
    }
    @GetMapping("/test21")
    McR test21() {
        String formInstanceId = "644298b7-6503-4576-a9f5-bb520bbe752d";//请假表单实例ID
        String userId = "1006793";
        Map formData = (Map) ydClient.queryData(YDParam.builder().formInstId(formInstanceId)
                .appType(ydConf.getAppType()).systemToken(ydConf.getSystemToken())
                .build(), YDConf.FORM_QUERY.retrieve_id).getFormData();
        List  employeeField_lts1mg30_id = (List) formData.get("employeeField_lts1mg30_id");
        List  departmentSelectField_lts1mg2z_id = (List) formData.get("departmentSelectField_lts1mg2z_id");
//        List  departmentSelectField_lys0k6qb_id = (List) formData.get("departmentSelectField_lys0k6qb_id");
//
        System.out.println("=="+employeeField_lts1mg30_id);
        formData.put("employeeField_lts1mg30", employeeField_lts1mg30_id);
        formData.put("departmentSelectField_lts1mg2z", departmentSelectField_lts1mg2z_id);
//        formData.put("departmentSelectField_lys0k6qb", departmentSelectField_lys0k6qb_id);

        System.out.println(formData);
        ydClient.operateData(YDParam.builder()
                .appType(ydConf.getAppType()).systemToken(ydConf.getSystemToken())
                .formUuid("FORM-A02F7EA3AD6548E59B8E1692AD729C77C5LD")
                .userId(userId)
                .formDataJson(JSON.toJSONString(formData))
                .build(), YDConf.FORM_OPERATION.start).toString();////
        return McR.success(formData);
    }
    @GetMapping("/test22")
    McR test22() {
        String formInstanceId = "d738e145-e0ca-4b1e-87c8-d278330041b7";
        String userId = "1007210";
        Map formData = (Map) ydClient.queryData(YDParam.builder().formInstId(formInstanceId)
                .appType(ydConf.getAppType()).systemToken(ydConf.getSystemToken())
                .build(), YDConf.FORM_QUERY.retrieve_id).getFormData();
        List  employeeField_lts8k71n_id = (List) formData.get("employeeField_lts8k71n_id");
        List  departmentSelectField_lts8k71m_id = (List) formData.get("departmentSelectField_lts8k71m_id");
        List  departmentSelectField_lx9uj3ds_id = (List) formData.get("departmentSelectField_lx9uj3ds_id");
//           List  employeeField_lwt3bde4_id = (List) formData.get("employeeField_lwt3bde4_id");
//        System.out.println("=="+employeeField_lts1mg30_id);
        formData.put("employeeField_lts8k71n", employeeField_lts8k71n_id);
        formData.put("departmentSelectField_lts8k71m", departmentSelectField_lts8k71m_id);
        formData.put("departmentSelectField_lx9uj3ds", departmentSelectField_lx9uj3ds_id);
//        formData.put("employeeField_lwt3bde4", employeeField_lwt3bde4_id);
        System.out.println(formData);
        ydClient.operateData(YDParam.builder()
                .appType(ydConf.getAppType()).systemToken(ydConf.getSystemToken())
                .formUuid("FORM-2C6A3F5B7A194F2390A5BA9677055295XVHL")
                .userId(userId)
                .formDataJson(JSON.toJSONString(formData))
                .build(), YDConf.FORM_OPERATION.start).toString();////
        return McR.success(formData);
    }
    @GetMapping("/test23")
    McR test23() {
        String formInstanceId = "1c934e55-cd5d-42e7-94b3-2a90cdb8c827";
        String userId = "1007443";
        Map formData = (Map) ydClient.queryData(YDParam.builder().formInstId(formInstanceId)
                .appType(ydConf.getAppType()).systemToken(ydConf.getSystemToken())
                .build(), YDConf.FORM_QUERY.retrieve_id).getFormData();
        List  employeeField_lu7zrcj3_id = (List) formData.get("employeeField_lu7zrcj3_id");
//        List  departmentSelectField_lts1mg2z_id = (List) formData.get("departmentSelectField_lts1mg2z_id");
        List  departmentSelectField_lu7zrcj4_id = (List) formData.get("departmentSelectField_lu7zrcj4_id");
//
//        System.out.println("=="+employeeField_lts1mg30_id);
        formData.put("employeeField_lu7zrcj3", employeeField_lu7zrcj3_id);
        formData.put("departmentSelectField_lu7zrcj4", departmentSelectField_lu7zrcj4_id);
//        formData.put("departmentSelectField_lys0k6qb", departmentSelectField_lys0k6qb_id);

        System.out.println(formData);
        ydClient.operateData(YDParam.builder()
                .appType(ydConf.getAppType()).systemToken(ydConf.getSystemToken())
                .formUuid("FORM-0AD770FAD54A47CA938A9D338C6FBB1BZ7AH")
                .userId(userId)
                .formDataJson(JSON.toJSONString(formData))
                .build(), YDConf.FORM_OPERATION.start).toString();////
        return McR.success(formData);
    }
    //刷新页面为最新版本
    @GetMapping("/test6")
    public McR test6() throws Exception {
        List<Map> datalist = ydService.queryFormData_all(YDParam.builder()
                        .formUuid("FORM-2C6A3F5B7A194F2390A5BA9677055295XVHL")
                        .build()
                );
        for (Map map : datalist) {
            ydClient.operateData(YDParam.builder()
                    .useLatestVersion(true)
                    .formInstanceId(UtilMap.getString(map, "formInstanceId"))
                    .updateFormDataJson(JSONObject.toJSONString(new HashMap<>()))
                    .build(), YDConf.FORM_OPERATION.update);
        }
        return McR.success();
    }
    @GetMapping("/test5" )
    public String test5() throws Exception {
        dingshiqiImpl dingshiqi = new dingshiqiImpl();
        List<Map> datalist = (List<Map>) ydClient.queryData(YDParam.builder()
                .formUuid("FORM-F7B0E685C56E41FC939A581F8B7C2665PXPV")
                .build(), YDConf.FORM_QUERY.retrieve_search_form).getData();

        for (Map map : datalist) {
            Map formData = (Map) map.get("formData");
            boolean flag = false;
            String instanceId = String.valueOf(formData.get("textField_lzns5l3k"));

            Map param2 = new HashMap();
            param2.put("x-acs-dingtalk-access-token", dingshiqi.getAccessToken_PJSS());
            Map body3 = new HashMap();
            body3.put("appType", "APP_VCTRP6227CC8368NDOID");
            body3.put("systemToken", "5H9662C1X8XJLFFCE841M5VBEBQ73DM5IBPULPI3");
            body3.put("processInstanceId", instanceId);
            body3.put("userId", YDConf.PUB_ACCOUNT);
            String taskId = "";
            String s = UtilHttp.doGet("https://api.dingtalk.com/v1.0/yida/processes/operationRecords", param2, (Map<String, Object>) body3);
            JSONObject obj = JSONObject.parseObject(s);
            JSONArray arr = obj.getJSONArray("result");
            for (int i = 0; i < arr.size(); i++) {
                JSONObject json = arr.getJSONObject(i);
                log.info("json:{},{}", json.getString("operatorUserId"),json.getString("type"));


                if (json.getString("operatorUserId").equals("13810479803") && json.getString("type").equals("TODO")) {
                    taskId = json.getString("taskId");
                    taskExecute(String.valueOf(formData.get("textField_lzns5l3k")),taskId);
                    flag = true;
                    break;
                }
            }
            if (flag) {
                ydClient.operateData(YDParam.builder()
                        .formInstanceId(UtilMap.getString(map, "formInstanceId"))
                        .build(), YDConf.FORM_OPERATION.delete);
            }
        }
        return "success";
    }
    private Map<String, String> getFormUuid(String type) {
        Map<String, String> map = UtilMap.empty();
        switch (type) {
            case "HT01"://合同
                map.put("type", "FORM-55D56A69CCCE4043A01660C8910E33BAQ4N0");
                map.put("sn", "serialNumberField_ltsbweh2");
                map.put("contractId", "textField_lwah8x72");
                break;
            case "CG11"://框架采购
                map.put("type", "FORM-82E566F8576E44D3AB4B34033A27E76FEB75");
                map.put("sn", "serialNumberField_ltsbweh2");
                map.put("contractId", "textField_lwah8x72");
                break;
            case "HT02"://框架
                map.put("type", "FORM-5DB656AF0F0E4EFA85A4739D55C23ED85BXO");
                map.put("sn", "serialNumberField_lvz8coae");
                map.put("contractId", "textField_lwg205ug");
                break;
            case "HT03"://租赁
                map.put("type", "FORM-FCDDD18FD63E49B2A4C652FBDB1874F6DPHW");
                map.put("sn", "serialNumberField_ltwcj54l");
                map.put("contractId", "textField_lwg1wbix");
                break;
            case "XZ04"://其他
                map.put("type", "FORM-B27C1AE7298648F29E836B5FDF469DBDPFCK");
                map.put("sn", "serialNumberField_ltwktal5");
                break;
            case "HTSG"://合同/申购
                map.put("type", "FORM-88F968E75CC340EB91B1AC692F4184DC9I9W");
                map.put("sn", "serialNumberField_lu7ycpuc");
                map.put("contractId", "textField_lwg219kl");
                break;
            case "HR09"://hr用印
                map.put("type", "FORM-54972289A0B7416287A9BA44DA6CCDC50QUC");
                map.put("sn", "serialNumberField_lu9euh7o");
                break;
            case "HR18"://新签劳动合同/协议
                map.put("type", "FORM-0D501EF1688247DC932E7784298BD46BRYHC");
                map.put("sn", "serialNumberField_luauhgb5");
                map.put("contractId", "textField_lwg241g6");
                break;
            case "XZ05"://发文审批
                map.put("type", "FORM-3E04D5456B2341CCBA62C955B791CF45IAH1");
                map.put("sn", "serialNumberField_ltwmutno");
                break;
            case "XZ08"://印章授权
                map.put("type", "FORM-87BD065161F84560B999FE94713255E20E6E");
                map.put("sn", "serialNumberField_ltwp3e44");
                break;
            case "XZQYLC"://加盟签约
                map.put("type", "FORM-53A0FB8715FB4378B0708794DFAF7089SV8P");
                map.put("sn", "serialNumberField_ltsaig24");
                break;
            case "HR02"://合同续签
                map.put("type", "FORM-FD73905FB9C24E3A99244F901D9C98AFH4E6");
                map.put("sn", "serialNumberField_lu991xi3");
                break;
        }
        return map;
    }
    @GetMapping("/test1" )
    public String test1() throws Exception {
//        List<Map> list = (List<Map>) ydClient.queryData(YDParam.builder().formUuid("FORM-5DB656AF0F0E4EFA85A4739D55C23ED85BXO")
//                .searchFieldJson(JSONObject.toJSONString(UtilMap.map("serialNumberField_lvz8coae", "HT02-KJLHEYY-202407240029")))
//                .build(), YDConf.FORM_QUERY.retrieve_list).getData();
//        String type = "FORM-88F968E75CC340EB91B1AC692F4184DC9I9W";
        String sn = "HTSG-202408120010";
        String[] sns = sn.split("-");
        dingshiqiImpl dingshiqi = new dingshiqiImpl();
        Map<String, String> formUuid = getFormUuid(sns[0]);
        List<Map> list1 = (List<Map>) ydClient.queryData(YDParam.builder().formUuid(formUuid.get("type")).searchCondition(
                JSONObject.toJSONString(UtilMap.map(formUuid.get("sn"), sn))
        ).build(), YDConf.FORM_QUERY.retrieve_list).getData();
        Map map = list1.get(0);
        String instanceId = (String) map.get("formInstanceId");
        Map data = (Map) ydClient.queryData(YDParam.builder().formInstId(instanceId)
                .appType(ydConf.getAppType()).systemToken(ydConf.getSystemToken())
                .userId(ddConf.getOperator()).build(), YDConf.FORM_QUERY.retrieve_id).getFormData();
        log.info("data:{}", data);
        log.info("list1:{}", list1);
        String categoryName = data.get(getCust(formUuid.get("type"), "categoryName")).toString();
//        String categoryName = list1.get("textField_lwa2350q");
        log.info("categoryName:{}", categoryName);
//        if(type.equals("FORM-B27C1AE7298648F29E836B5FDF469DBDPFCK")){
//            if(categoryName.equals("物理用印外带场景") || categoryName.equals("物理用印公司用印场景")){
//                String jsonString = data.get(getCust(type, "fujian1")).toString();
//            }else {
//                String jsonString = data.get(getCust(type, "fujian")).toString();
//            }
//        }else {
//            String jsonString = data.get(getCust(type, "fujian")).toString();
//        }
//        Map data = (Map) ydClient.queryData(YDParam.builder().formInstId("6a1ca03a-1d9c-4906-a328-881741543db8")
//                .appType(ydConf.getAppType()).systemToken(ydConf.getSystemToken())
//                .userId(ddConf.getOperator()).build(), YDConf.FORM_QUERY.retrieve_id).getFormData();
//        System.out.println("qaqqaq------------"+data);
//        String json = data.get("associationFormField_lvz8coby"+"_id").toString();
//        System.out.println("zzzz==========="+json);
//        String s = StringEscapeUtils.unescapeJava(json.substring(1, json.length() - 1));
//        List<Map> list1 = (List<Map>) JSONArray.parse(s);
//        for (Map map2 : list1) {
//            JSONObject auths = new JSONObject();
//            String subTitle = (String) map2.get("instanceId");
//            Map data1 = (Map) ydClient.queryData(YDParam.builder().formInstId(subTitle)
//                    .appType(ydConf.getAppType()).systemToken(ydConf.getSystemToken())
//                    .userId(ddConf.getOperator()).build(), YDConf.FORM_QUERY.retrieve_id).getFormData();
//            System.out.println("niu==================="+data1);
//            String aa = (String) data1.get("textField_lwywohh0");
//            String aa1 = (String) data1.get("textField_lw6aecve");
////            String aa2 = (String) data1.get("employeeField_lwr509pq_id");
//            ArrayList<Object> objects = new ArrayList<>();
//            Map hashMap = new HashMap();
//            hashMap.put("mobile",aa);
//            objects.add(hashMap);
//            auths.put("sealName", aa1);//印章名称
//            auths.put("count", 3);//授权数量
//            auths.put("users", objects);
//            System.out.println("qaq"+auths);
//            System.out.println("qqqq"+subTitle);
//        }
//        System.out.println("sssss======"+list1);
//        log.info("list:{}", list);
//        Map map = list.get(0);
//        Map formData = (Map) map.get("formData");
//        String json1 = formData.get("associationFormField_lvz8coby"+"_id").toString();
//        System.out.println("zzzz"+json1);
//        String s1 = StringEscapeUtils.unescapeJava(json.substring(1, json.length() - 1));
//        List<Map> list2 = (List<Map>) JSONArray.parse(s1);
//        System.out.println("zzzz"+list1);
//        for (Map map1 : list1) {
//            JSONObject auths = new JSONObject();
//
//            Object subTitle = map1.get("title");
//            ArrayList<Object> objects = new ArrayList<>();
//            auths.put("sealName", subTitle);//印章名称
//            auths.put("count", 3);//授权数量
//            System.out.println("qaq"+auths);
//            System.out.println("qqqq"+subTitle);
//        }
return "success";
    }
    @GetMapping("/test2")
    public String test2() throws Exception {
        dingshiqiImpl dingshiqi = new dingshiqiImpl();
//        String sn = param.get("sn");
//        String[] sns = sn.split("-");
//        Map<String, String> formUuid = getFormUuid(sns[0]);

//        List<Map> list1 = (List<Map>) ydClient.queryData(YDParam.builder().formUuid("FORM-0D501EF1688247DC932E7784298BD46BRYHC")
//                .searchFieldJson(JSONObject.toJSONString(UtilMap.map("serialNumberField_luauhgb5", "HR18-XQLDHT/XYLC-202408090020")))
//                .build(), YDConf.FORM_QUERY.retrieve_list).getData();
//        Map map = list1.get(0);
//        String instanceId = (String) map.get("formInstanceId");
        String instanceId = "68b97e35-4707-4cd5-bff8-c5118e2db4ce";
        Map param2 = new HashMap();
        param2.put("x-acs-dingtalk-access-token", dingshiqi.getAccessToken_PJSS());
        Map body3 = new HashMap();
        body3.put("appType","APP_VCTRP6227CC8368NDOID");
        body3.put("systemToken","5H9662C1X8XJLFFCE841M5VBEBQ73DM5IBPULPI3");
        body3.put("processInstanceId", instanceId);
        body3.put("userId","15099924886");
        boolean flag=true;
        do {
            String s = UtilHttp.doGet("https://api.dingtalk.com/v1.0/yida/processes/operationRecords", param2, (Map<String, Object>) body3);
            JSONObject obj=JSONObject.parseObject(s);
            JSONArray arr = obj.getJSONArray("result");
            for (int i = 0; i < arr.size(); i++) {
                JSONObject json = arr.getJSONObject(i);
                flag=false;
//                if(json.getString("operatorUserId").equals("13810479803")&&json.getString("type").equals("TODO")){
                    try {
                        taskExecute(instanceId,json.getString("taskId"));
                    }catch (McException e){
                        log.error("taskExecute error:{}",e.getMessage());
                    }

                    flag=true;
                    break;

//                }
            }
        }while (flag);
        return "success";
    }
    @GetMapping("/test10" )
    public List<Map> test() throws Exception {
//        dingshiqiImpl dingshiqi = new dingshiqiImpl();
//        List<Map> list = (List<Map>) ydClient.queryData(YDParam.builder().formUuid("FORM-5DB656AF0F0E4EFA85A4739D55C23ED85BXO")
//                .searchFieldJson(JSONObject.toJSONString(UtilMap.map("serialNumberField_lvz8coae", "HT02-KJLHEYY-202408090036")))
//                .build(), YDConf.FORM_QUERY.retrieve_list).getData();
//        log.info("list:{}", list);
        List<Map> LegaltList = new ArrayList<>();
        String sql = "select  *  from  V_SEAL_COM_USER where  miaosu ='电子' order by gszt";
        String jdbcUrl = "jdbc:mysql://10.9.33.236/qiyuesuodb?useSSL=false&characterEncoding=UTF-8&serverTimezone=UTC";
        String userName = "root";
        String password = "hpZbPf6YnVr7";
        try{
            Class.forName("com.mysql.cj.jdbc.Driver");
            Connection conn = DriverManager.getConnection(jdbcUrl, userName, password);
            Statement statement = conn.createStatement();
            ResultSet resultSet = statement.executeQuery(sql);
            int i=0;
            while (resultSet.next()){
                i++;
                System.out.println(i+"-"+resultSet.getFetchSize());
                System.out.println(resultSet.getString("yzsysmz"));//看进度用
                System.out.println(resultSet.getString("yzsyzid"));//名称
                System.out.println(resultSet.getString("gszt"));//名称
                System.out.println(resultSet.getString("id"));//名称
                String yzsysmz = resultSet.getString("yzsysmz");//编号
                String yzsyzid = resultSet.getString("yzsyzid");//名称
                String gszt = resultSet.getString("gszt");//名称
                String id = resultSet.getString("id");//名称
                HashMap<String, Object> bankmap = new HashMap<>();
                bankmap.put("yzsysmz",yzsysmz);
                bankmap.put("yzsyzid",yzsyzid);
                bankmap.put("gszt",gszt);
                bankmap.put("id",id);
                LegaltList.add(bankmap);
            }
            resultSet.close();
            statement.close();
            conn.close();
        }catch (Exception e){
            e.printStackTrace();
        }
//        Map map = list.get(0);
//        String instanceId = (String) map.get("formInstanceId");
//        Map formData = (Map) map.get("formData");
//        String lss = formData.toString();
//        String json = formData.get("associationFormField_lzaq7kz8_id").toString();
//        String s = StringEscapeUtils.unescapeJava(json.substring(1, json.length() - 1));
//        List<Map> list1 = (List<Map>) JSONArray.parse(s);
//        System.out.println("zzzz"+list1);
//        for (Map map1 : list1) {
//            Object subTitle = map1.get("subTitle");
//            System.out.println("qqqq"+subTitle);
//        }
//
////        List<String> subTitleValues = getSubTitles(formData);
//        Map param2 = new HashMap();
//        param2.put("x-acs-dingtalk-access-token", dingshiqi.getAccessToken_PJSS());
//        System.out.println("x-acs-dingtalk-access-token"+ddClient.getAccessToken());
//        Map body3 = new HashMap();
////        body3.put("outResult","AGREE");
//        body3.put("appType","APP_VCTRP6227CC8368NDOID");
//        body3.put("systemToken","5H9662C1X8XJLFFCE841M5VBEBQ73DM5IBPULPI3");
////        body3.put("remark","同意");
//        body3.put("processInstanceId", instanceId);
//        body3.put("userId","13810479803");
//        boolean flag=true;
//        do {
//            String s = UtilHttp.doGet("https://api.dingtalk.com/v1.0/yida/processes/operationRecords", param2, (Map<String, Object>) body3);
//            System.out.println("555"+s);
//            JSONObject obj=JSONObject.parseObject(s);
//            JSONArray arr = obj.getJSONArray("result");
//            for (int i = 0; i < arr.size(); i++) {
//                JSONObject json = arr.getJSONObject(i);
//                flag=false;
//                if(json.getString("operatorUserId").equals("13810479803")&&json.getString("type").equals("TODO")){
//                    taskExecute(instanceId,json.getString("taskId"));
//                    flag=true;
//                    break;
//                }
//            }
//        }while (flag);
        return LegaltList;
    }
    @Autowired
    private QysService qysService1;
//@GetMapping("/test12" )
//public String test12() throws Exception {
//    qysService1.download1("contractId");
//    List<String> unzippedFiles = new ArrayList<>();
//    String zipFilePath = BDURL + sn + ".zip";
//    String destDirectory = PDFBDURL + sn;
//    try {
//        File destDir = new File(destDirectory);
//        if (!destDir.exists()) {
//            destDir.mkdir();
//        }
//        byte[] buffer = new byte[1024];
//        ZipInputStream zipIn = new ZipInputStream(new FileInputStream(zipFilePath));
//        ZipEntry entry = zipIn.getNextEntry();
//        while (entry != null) {
//            String filePath = destDirectory + File.separator + entry.getName();
//            if (!entry.isDirectory()) {
//                new File(filePath).getParentFile().mkdirs();
//                FileOutputStream fos = new FileOutputStream(filePath);
//                int len;
//                while ((len = zipIn.read(buffer)) > 0) {
//                    fos.write(buffer, 0, len);
//                }
//                fos.close();
//                unzippedFiles.add(filePath);
//            }
//            zipIn.closeEntry();
//            entry = zipIn.getNextEntry();
//        }
//        zipIn.close();
//        System.out.println("ZIP 文件解压完成。");
//    } catch (Exception e) {
//        System.out.println("发生异常: " + e.getMessage());
//        e.printStackTrace();
//    }
//    for (String unzippedFile : unzippedFiles) {
//        Map map = new HashMap();
//        String fileName = FileUtil.getName(unzippedFile);
//        map.put("downloadUrl", URL + sn + "/" + fileName);
//        map.put("name", fileName);
//        map.put("previewUrl", map.get("downloadUrl"));
//        map.put("url", map.get("downloadUrl"));
//        map.put("ext", FileUtil.extName(unzippedFile));
//        list.add(map);
//    }
//    log.info("list:{}", list);
//
//}
    @GetMapping("/test11" )
    public String test11() throws Exception {
        Map data = (Map) ydClient.queryData(YDParam.builder().formInstId("4b3fdbdf-3aef-4fe8-9eef-d4966b61e8d4")
                .appType(ydConf.getAppType()).systemToken(ydConf.getSystemToken())
                .userId(ddConf.getOperator()).build(), YDConf.FORM_QUERY.retrieve_id).getFormData();
        log.info("data:{}", data);
        String sfbh = data.get("selectField_lu9euh7u").toString();
        System.out.println("aaaaaaaaa"+sfbh);
        return "success";
    }
    private void taskExecute(String instanceId,String taskId){
        Map param3 = new HashMap();
        param3.put("x-acs-dingtalk-access-token",new dingshiqiImpl().getAccessToken_PJSS());
        Map body4 = new HashMap();
        body4.put("outResult","AGREE");
        body4.put("appType","APP_VCTRP6227CC8368NDOID");
        body4.put("systemToken","5H9662C1X8XJLFFCE841M5VBEBQ73DM5IBPULPI3");
        body4.put("remark","同意");
        body4.put("taskId",taskId);
        body4.put("processInstanceId", instanceId);
        body4.put("userId","15099924886");
        String s1 = UtilHttp.doPost("https://api.dingtalk.com/v1.0/yida/tasks/execute", param3,null, (Map<String, Object>) body4);
        System.out.println("result"+s1);
    }
    /***
     * 第三步
     * 契约锁签署完成回调、保存文件
     * @return
     */
    @PostMapping("/callback")
    public String  callback(@RequestParam Map<String, String> param) throws Exception {
        log.info("callback:{}", JSON.toJSONString(param));

        //1.content解析为json字符   并获得contractId
        //2.根据contractId 获取附件到本地获得一个本地地址  接口：/contract/download zip保存到本地   并解压zip

        //3.根据contractId查询对应的数据实例ID，根据实例ID把本地地址对的文件传到对应的 附件签署后

        //("attachmentField_ltsbweit",文件)
        return qysService.callback(param);
    }
    @PostMapping("/callback1")
    public String  callback1(@RequestParam Map<String, String> param) throws Exception {
        log.info("callback:{}", param);

        return qysService.callback1(param);
    }

    private static final String FILE_DIRECTORY = "/home/server/ruisi_qys/ruisi_qiyuesuo/fils_new/";

    @GetMapping("/download/{sn}/{fileName}")
    public ResponseEntity<Resource> downloadFile(@PathVariable String fileName,@PathVariable String sn) {
        Path filePath = Paths.get(FILE_DIRECTORY.concat(sn.concat("//"))).resolve(fileName).normalize();
        try {
            Resource resource = new UrlResource(filePath.toUri());
            if (resource.exists()) {
                HttpHeaders headers = new HttpHeaders();
                headers.add(HttpHeaders.CONTENT_DISPOSITION, "attachment; filename=" + resource.getFilename());
                return ResponseEntity.ok()
                        .headers(headers)
                        .contentType(MediaType.parseMediaType("application/octet-stream"))
                        .body(resource);
            } else {
                return ResponseEntity.notFound().build();
            }
        } catch (MalformedURLException e) {
            return ResponseEntity.notFound().build();
        } catch (IOException e) {
            return ResponseEntity.notFound().build();
        }
    }
    private String getCust(String type, String key) throws Exception {
        Map<String, String> map = UtilMap.empty();
        if (type.equals("FORM-55D56A69CCCE4043A01660C8910E33BAQ4N0")) {
            // 合同用印 组件编号
            map.put("subject", "textField_ltsbwegw");//合同名称
            map.put("sn", "serialNumberField_ltsbweh2");//合同编号
            map.put("tenantName", "textField_lvz1kozf");//公司名称
            map.put("tenantName1", "textField_lznvplmm");//印章公司名称
            map.put("creatorName", "textField_lzpdjzfp");//创建人名称
            map.put("creatorContact", "textField_lzpdjzfq");//创建人手机号
            map.put("glbd", "associationFormField_lu0u6npd");//物理印章关联表单
            map.put("categoryId", "textField_lvm5xmqe");//业务分类Id
            map.put("contractId", "textField_lwah8x72");//合同Id
            map.put("categoryName", "textField_lvz1kozg");//业务分类名称
            map.put("fujian", "attachmentField_ltsbweir");//附件
            map.put("creatorName", "employeeField_ltsbwefl");//创建人姓名
            map.put("applyerNumber", "textField_lwebkb16");//创建人员工编号
            map.put("sealName", "textField_lvw4umfr");//授权印章名称
            map.put("count", "numberField_ltwa0vj6");//授权次数
            map.put("mobile", "textField_lwzqvg93");//授权人手机号
            map.put("tenantNameP", "textField_ltwa0vke");//对方个人签署人姓名
            map.put("contactP", "textField_ltwa0vkf");//对方个人签署人联系电话
            map.put("tenantNameA", "textField_ltwa0vk0");//对方公司名称
            map.put("receiverNameA", "textField_ltwa0vk1");//对方公司签署人名称
            map.put("contactA", "textField_ltwa0vk2");//对方公司签署人联系电话
        } else if (type.equals("FORM-5DB656AF0F0E4EFA85A4739D55C23ED85BXO")) {
            // 框架类用印
            map.put("subject", "textField_lvz8coad");//合同名称
            map.put("sn", "serialNumberField_lvz8coae");//合同编号
            map.put("tenantName", "textField_lvza5uwu");//公司名称
            map.put("creatorName", "textField_lzpdjzfp");//创建人名称
            map.put("creatorContact", "textField_lzpdjzfq");//创建人手机号
            map.put("tenantName1", "textField_lznvplmm");//印章公司名称
            map.put("glbd", "associationFormField_lvz8coby");//物理印章关联表单
            map.put("categoryId", "textField_lvz8cobe");//业务分类Id
            map.put("contractId", "textField_lwg205ug");//合同Id
            map.put("categoryName", "textField_lvz8cobd");//业务分类名称
            map.put("fujian", "attachmentField_lvz8cocl");//附件
            map.put("creatorName", "employeeField_lvz8co98");//创建人姓名
            map.put("applyerNumber", "textField_lweccz0q");//创建人员工编号
            map.put("sealName", "textField_lwelg27e");//授权印章名称
            map.put("mobile", "textField_lwzqvg93");//授权人手机号
            map.put("count", "numberField_lvz8cobz");//授权次数
            map.put("tenantNameP", "textField_lvz8cocg");//对方个人签署人姓名
            map.put("contactP", "textField_lvz8coce");//对方个人签署人联系电话
            map.put("tenantNameA", "textField_lvz8coc5");//对方公司名称
            map.put("receiverNameA", "textField_lvz8coc6");//对方公司签署人名称
            map.put("contactA", "textField_lvz8coc7");//对方公司签署人联系电话

        } else if (type.equals("FORM-B27C1AE7298648F29E836B5FDF469DBDPFCK")) {
            // 其他用印
            map.put("subject", "textField_ltwktal4");//合同名称
            map.put("sn", "serialNumberField_ltwktal5");//合同编号
            map.put("tenantName", "textField_lvz45lif");//公司名称
            map.put("creatorName", "textField_lzpdjzfp");//创建人名称
            map.put("creatorContact", "textField_lzpdjzfq");//创建人手机号
            map.put("tenantName1", "textField_lznvplmm");//印章公司名称
            map.put("categoryId", "textField_lvz45lii");//业务分类Id
            map.put("glbd", "associationFormField_lu0w0l7x");//物理印章关联表单
            map.put("contractId", "textField_lwg1z6hk");//合同Id
            map.put("applyerNumber", "textField_lwelap55");//创建人员工编号
            map.put("sealName", "textField_lx1gzqai");//授权印章名称
            map.put("mobile", "textField_lwzqvg93");//授权人手机号
            map.put("count", "numberField_ltwktalp");//授权次数
            map.put("categoryName", "textField_lvz45lih");//业务分类名称
            map.put("fujian", "attachmentField_ltwktamq");//附件
//            map.put("creatorName", "employeeField_ltwktal6");//创建人姓名
//            map.put("creatorContact", "textField_ltsbwef1");//创建人联系方式
//            map.put("receiverNameP", "textField_ltwa0vke");//对方个人签署人姓名
//            map.put("contactP", "textField_ltwa0vkf");//对方个人签署人联系电话
//            map.put("tenantNameA", "textField_ltwa0vk0");//对方公司名称
//            map.put("receiverNameA", "textField_ltwa0vk1");//对方公司签署人名称
//            map.put("contactA", "textField_ltwa0vk2");//对方公司签署人联系电话
        } else if (type.equals("FORM-FCDDD18FD63E49B2A4C652FBDB1874F6DPHW")) {
            // 租赁类用印 组件编号
            map.put("subject", "textField_ltwcj54k");//合同名称
            map.put("sn", "serialNumberField_ltwcj54l");//合同编号
            map.put("tenantName", "textField_lvz3j6lq");//公司名称
            map.put("tenantName1", "textField_lznvplmm");//公司名称
            map.put("creatorName", "textField_lzpdjzfp");//创建人名称
            map.put("creatorContact", "textField_lzpdjzfq");//创建人手机号
            map.put("glbd", "associationFormField_lu0vkwu7");//物理印章关联表单
            map.put("categoryId", "textField_lvz3j6ls");//业务分类Id
            map.put("contractId", "textField_lwg1wbix");//合同Id
            map.put("sealName", "textField_lwel4lyr");//授权印章名称
            map.put("count", "numberField_ltwe0wyo");//授权次数
            map.put("mobile", "textField_lwzqvg93");//授权人手机号
            map.put("categoryName", "textField_ltwe0wyb");//业务分类名称
            map.put("fujian", "attachmentField_ltwe0wyz");//附件
            map.put("creatorName", "employeeField_ltwcj52j");//创建人姓名
            map.put("applyerNumber", "textField_lwel4lyq");//创建人员工编号
//            map.put("creatorContact", "textField_ltsbwef1");//创建人联系方式
            map.put("tenantNameP", "textField_ltwe0wyw");//对方个人签署人姓名
            map.put("contactP", "textField_ltwe0wyx");//对方个人签署人联系电话
            map.put("tenantNameA", "textField_ltwe0wyq");//对方公司名称
            map.put("receiverNameA", "textField_ltwe0wyr");//对方公司签署人名称
            map.put("contactA", "textField_ltwe0wys");//对方公司签署人联系电话
        } else if (type.equals("FORM-53A0FB8715FB4378B0708794DFAF7089SV8P")) {
            // 加盟签约
            map.put("subject", "textField_ltrzli9n");//合同名称
            map.put("sn", "serialNumberField_ltsaig24");//合同编号
            map.put("tenantName", "textField_lybee634");//公司名称
            map.put("categoryId", "textField_lw4tkat0");//业务分类Id
            map.put("creatorName", "textField_lzpdjzfp");//创建人名称
            map.put("creatorContact", "textField_lzpdjzfq");//创建人手机号
            map.put("glbd", "associationFormField_lwso6sgd");//物理印章关联表单
            map.put("fujian", "attachmentField_luhu041t");//附件
//            map.put("creatorName", "employeeField_ltrzli8r");//创建人姓名
            map.put("categoryName", "textField_lvz1kozg");//业务分类名称
            map.put("tenantNameP", "textField_lts1g8sc");//对方个人签署人姓名
            map.put("applyerNumber", "textField_lybee62y");//创建人员工编号
            map.put("sealName", "textField_lybee635");//授权印章名称
            map.put("count", "numberField_lts1g8r9");//授权次数
            map.put("contactP", "textField_lts1g8sd");//对方个人签署人联系电话
            map.put("tenantNameA", "textField_lts1g8rs");//对方公司名称
            map.put("receiverNameA", "textField_lts1g8ru");//对方公司签署人名称
            map.put("contactA", "textField_lts1g8rt");//对方公司签署人联系电话
        } else if (type.equals("FORM-88F968E75CC340EB91B1AC692F4184DC9I9W")) {
            // 合同/申购流程
            map.put("subject", "textField_lu7ycpub");//合同名称
            map.put("sn", "serialNumberField_lu7ycpuc");//合同编号
            map.put("tenantName", "textField_lygvcsw5");//公司名称textField_lu81zom2
            map.put("tenantName1", "textField_lznvplmm");//公司名称
            map.put("creatorName", "textField_lzpdjzfp");//创建人名称
            map.put("creatorContact", "textField_lzpdjzfq");//创建人手机号
            map.put("glbd", "associationFormField_lwrmm4p7");//物理印章关联表单
            map.put("categoryId", "textField_lw05x5rm");//业务分类Id
            map.put("contractId", "textField_lwg219kl");//合同Id
            map.put("mobile", "textField_lwzqvg93");//授权人手机号
            map.put("categoryName", "textField_lwa2350q");//业务分类名称
            map.put("fujian", "attachmentField_lu81zomp");//附件
            map.put("applyerNumber", "textField_lwelmmkr");//创建人员工编号
            map.put("sealName", "textField_lwelmmks");//授权印章名称
            map.put("count", "numberField_lual6ol8");//授权次数
//            map.put("creatorName", "employeeField_ltsbwefl");//创建人姓名
//            map.put("creatorContact", "textField_ltsbwef1");//创建人联系方式
            map.put("tenantNameP", "textField_lu81zome");//对方个人签署人姓名
            map.put("contactP", "textField_lu81zomf");//对方个人签署人联系电话
            map.put("tenantNameA", "textField_lu81zomd");//对方公司名称
            map.put("receiverNameA", "textField_lu81zome");//对方公司签署人名称
            map.put("contactA", "textField_lu81zomf");//对方公司签署人联系电话

        } else if (type.equals("FORM-54972289A0B7416287A9BA44DA6CCDC50QUC")) {
            // HR用印
            map.put("subject", "textField_lu9euh7n");//合同名称
            map.put("sn", "serialNumberField_lu9euh7o");//合同编号
            map.put("tenantName", "textField_lvzz59hk");//公司名称
            map.put("tenantName1", "textField_lznvplmm");//公司名称
            map.put("creatorName", "textField_lzpdjzfp");//创建人名称
            map.put("creatorContact", "textField_lzpdjzfq");//创建人手机号
            map.put("glbd", "associationFormField_lu9euh8b");//物理印章关联表单
            map.put("categoryId", "textField_lvzz59hn");//业务分类Id
            map.put("contractId", "textField_lwg22nvj");//合同Id
            map.put("mobile", "textField_lwzqvg93");//授权人手机号
            map.put("categoryName", "textField_lvzz59hm");//业务分类名称
            map.put("applyerNumber", "textField_lweezm68");//创建人员工编号
            map.put("sealName", "textField_lweezm69");//授权印章名称
            map.put("count", "numberField_lu9euh8c");//授权次数
            map.put("fujian", "attachmentField_lu9euh8d");//附件
        } else if (type.equals("FORM-0D501EF1688247DC932E7784298BD46BRYHC")) {
            // 新签劳动合同/协议
            map.put("subject", "textField_luauhgb4");//合同名称
            map.put("sn", "serialNumberField_luauhgb5");//合同编号
            map.put("tenantName", "textField_lw4rpz1w");//公司名称
            map.put("categoryId", "textField_lw4rpz1x");//业务分类Id
            map.put("creatorName", "textField_lzpdjzfp");//创建人名称
            map.put("creatorContact", "textField_lzpdjzfq");//创建人手机号
            map.put("mobile", "textField_lwzqvg93");//授权人手机号
            map.put("contractId", "textField_lwg241g6");//合同Id
            map.put("jf", "textField_lwk0stof");//甲方名称
            map.put("txdz", "textField_lup3q6ke");//甲方通讯地址
            map.put("yf", "textField_lup3q6kf");//乙方
            map.put("sjhm", "textField_lup3q6kg");//乙方手机号码
            map.put("syqksrq", "dateField_lup3q6kv");//试用期开始日期
            map.put("syqjsrq", "dateField_lup3q6kw");//试用期结束日期
            map.put("ldhtksrq", "dateField_lup3q6kx");//劳动合同开始日期
            map.put("ldhtjsrq", "dateField_lup3q6ky");//劳动合同结束日期
            map.put("gzdd", "textField_lup3q6kk");//工作地点
            map.put("yftgfw", "textField_lup3q6kh");//乙方提供服务
            map.put("xchsgz", "selectField_lup3q6ki");//薪酬核算规则
            map.put("dyzmtbc", "numberField_lup3q6kj");//报酬金额
            map.put("dyzarksrq", "dateField_lup3q6kl");//开始日期
            map.put("dyzarjsrq", "dateField_lup3q6km");//结束日期
            map.put("contractId", "textField_lwg241g6");//合同Id
            map.put("categoryName", "textField_lwa1xm1p");//业务分类名称
            map.put("tenantNameP", "textField_lup3q6kf");//对方个人签署人姓名
            map.put("contactP", "textField_lup3q6kg");//对方个人签署人联系电话
        } else if (type.equals("FORM-3E04D5456B2341CCBA62C955B791CF45IAH1")) {
            // 发文审批用印
            map.put("subject", "textField_ltwmutnp");//合同名称
            map.put("sn", "serialNumberField_ltwmutno");//合同编号
            map.put("tenantName", "textField_lw044nmp");//公司名称
            map.put("tenantName1", "textField_lznvplmm");//公司名称
            map.put("creatorName", "textField_lzpdjzfp");//创建人名称
            map.put("creatorContact", "textField_lzpdjzfq");//创建人手机号
            map.put("categoryId", "textField_lw044nmr");//业务分类Id
            map.put("glbd", "associationFormField_lu6mvmik");//物理印章关联表单
            map.put("contractId", "textField_lwg251gn");//合同Id
            map.put("mobile", "textField_lwzqvg93");//授权人手机号
            map.put("categoryName", "textField_ltwmutoc");//业务分类名称
            map.put("applyerNumber", "textField_lweluap2");//创建人员工编号
            map.put("sealName", "textField_lweluap3");//授权印章名称
            map.put("count", "numberField_ltwmutow");//授权次数
            map.put("fujian", "attachmentField_ltwmutq4");//附件
        } else if (type.equals("FORM-87BD065161F84560B999FE94713255E20E6E")) {
            //印章授权&承诺书
            map.put("subject", "textField_ltwp3e43");//合同名称
            map.put("sn", "serialNumberField_ltwp3e44");//合同编号
            map.put("tenantName", "textField_lw04hhp1");//公司名称
            map.put("categoryId", "textField_lw04hhp3");//业务分类Id
            map.put("creatorName", "textField_lzpdjzfp");//创建人名称
            map.put("creatorContact", "textField_lzpdjzfq");//创建人手机号
            map.put("contractId", "textField_lwg260n6");//合同Id
            map.put("mobile", "textField_lwzqvg93");//授权人手机号
            map.put("categoryName", "textField_lwa29saw");//业务分类名称
            map.put("fujian", "attachmentField_ltwp3e4g");//附件
            map.put("tenantNameP", "textField_lw93mjk9");//授权人姓名
            map.put("contactP", "textField_ltwp3e4d");//授权人联系电话
            map.put("tenantNameA", "textField_lw93mjka");//被授权人姓名
            map.put("contactA", "textField_ltwp3e4f");//被授权人联系电话
        } else if (type.equals("FORM-FD73905FB9C24E3A99244F901D9C98AFH4E6")) {
            //合同续签流程
            map.put("subject", "textField_lu991xi2");//合同名称
            map.put("sn", "serialNumberField_lu991xi3");//合同编号
            map.put("tenantName", "textField_lvz1kozf");//公司名称
            map.put("categoryId", "textField_lvm5xmqe");//业务分类Id
            map.put("categoryName", "textField_lvz1kozg");//业务分类名称
            map.put("creatorName", "textField_lzpdjzfp");//创建人名称
            map.put("creatorContact", "textField_lzpdjzfq");//创建人手机号
            map.put("contact", "textField_lu991xih");//续签人手机号码
            map.put("jf", "textField_lvz1kozf");//公司主体名称
            map.put("sfzh", "textField_lu991xig");//续签人身份证号码
            map.put("xm", "textField_lzkz3mkq");//续签人姓名
            map.put("htkssj", "dateField_lu991xii");//合同开始时间
            map.put("htjssj", "dateField_lu991xij");//合同结束时间
            map.put("xdqxkssj", "dateField_lu991xim");//续订期限开始时间
            map.put("xdqxjzsj", "dateField_lu991xin");//续订期限结束时间
            map.put("zfjjbcjrq", "dateField_lzl3nrxf");//续订期限结束时间
            map.put("jjbcj", "numberField_lzl3nrxg");//续订期限结束时间
        } else {
            throw new Exception();
        }
        return map.get(key);
    }
}



