package com.malk.ruisi.controller;

import cn.hutool.core.io.FileUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.malk.ruisi.service.dingshiqi;
import com.malk.ruisi.service.impl.dingshiqiImpl;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McException;
import com.malk.service.aliwork.YDClient;
import com.malk.utils.UtilHttp;
import com.malk.utils.UtilMap;
import lombok.extern.slf4j.Slf4j;
import org.apache.tomcat.util.http.fileupload.FileUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;

import java.io.File;
import java.io.IOException;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Slf4j
@Configuration
@EnableScheduling
@ConditionalOnProperty(name = {"enable.scheduling"})
public class ScheduleTask {
    @Autowired
    private dingshiqi ds;
    @Value("${qiyuesuo.pdfbdurl}")
    private String PDFBDURL;

    @Value("${qiyuesuo.bdurl}")
    private String BDURL;
    @Autowired
    private YDClient ydClient;

    /**
     * 每月查询业务ID
     */
    @Scheduled(cron = "0 23 12 * * ?")
//    @Scheduled(cron = "0 0 4 * * ?")
    public void syncRecruitSource() {
        try {
            System.out.println("开始上传业务ID");
            System.out.println(LocalDateTime.now());
            ds.getYWFLid();
            System.out.println("结束业务ID");
        } catch (Exception e) {
            // 记录错误信息
            e.printStackTrace();
        }
    }

    /**
     * 每月查询物理印章ID
     */
    @Scheduled(cron = "0 45 3 * * ?")
//    @Scheduled(cron = "0 26 11 * * ?")
//   @Scheduled(cron = "0/1 * * * * ?")
    public void syncRecruitSource1() {
        try {
            System.out.println("开始上传物理印章ID");
            System.out.println(LocalDateTime.now());
            ds.getYWFLid1();
            System.out.println("结束物理印章ID");
        } catch (Exception e) {
            // 记录错误信息
            e.printStackTrace();
        }
    }

    //    @Scheduled(cron = "0/1 * * * * ?")
    @Scheduled(cron = "0 0/10 * * * ?")
    public void syncRecruitSource3() {
        dingshiqiImpl dingshiqi = new dingshiqiImpl();
        List<Map> datalist = (List<Map>) ydClient.queryData(YDParam.builder()
                .formUuid("FORM-F7B0E685C56E41FC939A581F8B7C2665PXPV")
                .build(), YDConf.FORM_QUERY.retrieve_search_form).getData();

        for (Map map : datalist) {
            Map formData = (Map) map.get("formData");
            String instanceId = String.valueOf(formData.get("textField_lzns5l3k"));
            String taskId = (String) formData.get("textField_lzns5l3m");

            if (taskId.equals("0")) {
                Map param2 = new HashMap();
                param2.put("x-acs-dingtalk-access-token", dingshiqi.getAccessToken_PJSS());
                Map body3 = new HashMap();
                body3.put("appType", "APP_VCTRP6227CC8368NDOID");
                body3.put("systemToken", "5H9662C1X8XJLFFCE841M5VBEBQ73DM5IBPULPI3");
                body3.put("processInstanceId", instanceId);
                body3.put("userId", YDConf.PUB_ACCOUNT);
                String s = UtilHttp.doGet("https://api.dingtalk.com/v1.0/yida/processes/operationRecords", param2, (Map<String, Object>) body3);
                JSONObject obj = JSONObject.parseObject(s);
                JSONArray arr = obj.getJSONArray("result");
                for (int i = 0; i < arr.size(); i++) {
                    JSONObject json = arr.getJSONObject(i);
                    log.info("json:{},{}", json.getString("operatorUserId"), json.getString("type"));
                    if (json.getString("operatorUserId").equals("13810479803") && json.getString("type").equals("TODO")) {
                        taskId = json.getString("taskId");
                        break;
                    }
                }
            }

            if (!taskId.equals("0")) {
                taskExecute(instanceId, taskId);

                ydClient.operateData(YDParam.builder()
                        .formInstanceId(UtilMap.getString(map, "formInstanceId"))
                        .build(), YDConf.FORM_OPERATION.delete);
            }
        }

    }

    private Map<String, String> getFormUuid(String type) {
        Map<String, String> map = UtilMap.empty();
        switch (type) {
            case "HT01"://合同
                map.put("type", "FORM-55D56A69CCCE4043A01660C8910E33BAQ4N0");
                map.put("sn", "serialNumberField_ltsbweh2");
                map.put("contractId", "textField_lwah8x72");
                break;
            case "CG11"://框架采购
                map.put("type", "FORM-82E566F8576E44D3AB4B34033A27E76FEB75");
                map.put("sn", "serialNumberField_ltsbweh2");
                map.put("contractId", "textField_lwah8x72");
                break;
            case "HT02"://框架
                map.put("type", "FORM-5DB656AF0F0E4EFA85A4739D55C23ED85BXO");
                map.put("sn", "serialNumberField_lvz8coae");
                map.put("contractId", "textField_lwg205ug");
                break;
            case "HT03"://租赁
                map.put("type", "FORM-FCDDD18FD63E49B2A4C652FBDB1874F6DPHW");
                map.put("sn", "serialNumberField_ltwcj54l");
                map.put("contractId", "textField_lwg1wbix");
                break;
            case "XZ04"://其他
                map.put("type", "FORM-B27C1AE7298648F29E836B5FDF469DBDPFCK");
                map.put("sn", "serialNumberField_ltwktal5");
                break;
            case "HTSG"://合同/申购
                map.put("type", "FORM-88F968E75CC340EB91B1AC692F4184DC9I9W");
                map.put("sn", "serialNumberField_lu7ycpuc");
                map.put("contractId", "textField_lwg219kl");
                break;
            case "HR03"://hr用印
                map.put("type", "FORM-54972289A0B7416287A9BA44DA6CCDC50QUC");
                map.put("sn", "serialNumberField_lu9euh7o");
                break;
            case "HR18"://新签劳动合同/协议
                map.put("type", "FORM-0D501EF1688247DC932E7784298BD46BRYHC");
                map.put("sn", "serialNumberField_luauhgb5");
                map.put("contractId", "textField_lwg241g6");
                break;
            case "XZ05"://发文审批
                map.put("type", "FORM-3E04D5456B2341CCBA62C955B791CF45IAH1");
                map.put("sn", "serialNumberField_ltwmutno");
                break;
            case "XZ08"://印章授权
                map.put("type", "FORM-87BD065161F84560B999FE94713255E20E6E");
                map.put("sn", "serialNumberField_ltwp3e44");
                break;
            case "XZQYLC"://加盟签约
                map.put("type", "FORM-53A0FB8715FB4378B0708794DFAF7089SV8P");
                map.put("sn", "serialNumberField_ltsaig24");
                break;
            case "HR02"://合同续签
                map.put("type", "FORM-FD73905FB9C24E3A99244F901D9C98AFH4E6");
                map.put("sn", "serialNumberField_lu991xi3");
                break;
        }
        return map;
    }

    private void taskExecute(String instanceId, String taskId) {
        Map param3 = new HashMap();
        param3.put("x-acs-dingtalk-access-token", new dingshiqiImpl().getAccessToken_PJSS());
        Map body4 = new HashMap();
        body4.put("outResult", "AGREE");
        body4.put("appType", "APP_VCTRP6227CC8368NDOID");
        body4.put("systemToken", "5H9662C1X8XJLFFCE841M5VBEBQ73DM5IBPULPI3");
        body4.put("remark", "同意");
        body4.put("taskId", taskId);
        body4.put("processInstanceId", instanceId);
        body4.put("userId", "13810479803");
        String s1 = UtilHttp.doPost("https://api.dingtalk.com/v1.0/yida/tasks/execute", param3, null, (Map<String, Object>) body4);
        System.out.println("result" + s1);
    }

    /**
     * 每月查询电子印章ID
     * //
     */
    @Scheduled(cron = "0 30 3 * * ?")
//    @Scheduled(cron = "0 48 14 * * *")
    public void syncRecruitSource2() {
        try {
            System.out.println("开始上传电子印章ID");
            System.out.println(LocalDateTime.now());
            ds.getYWFLid2();
            System.out.println("结束电子印章ID");
        } catch (Exception e) {
            // 记录错误信息
            e.printStackTrace();
        }
    }

    @Scheduled(cron = "0 1 0 * * SUN")
//    @Scheduled(cron = "0 0 * * 0")
//@Scheduled(cron = "0 0 0 * * ?")
    public void delTempFile() {
        log.info("开始删除文件");
        File directory = new File(BDURL);
        try {
            FileUtils.cleanDirectory(directory);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

//                @Scheduled(cron = "0/1 * * * * ?")
    public void syncDelete() {

        log.info("开始删除数据");

        try {
            ds.syncDelete();
            System.out.println(LocalDateTime.now());
        } catch (Exception e) {
            // 记录错误信息
            e.printStackTrace();
        }
    }
}
